
// - - - - - NOTE: - - - - - //
// Most of this code was taken from the TIGCC tools suite program "ttstart"
// Changes by Angelboy
// Below is some original information:


/*
*
* project name:    TIGCC Tools Suite
* file name:       ttstart.c
* initial date:    14/08/2000
* author:          thomas.nussbaumer@gmx.net
* description:     start utility for exepacked and/or normal executables */

#define NO_EXIT_SUPPORT     // the launcher doesn't need exit support
#define NO_CALC_DETECT      // it doesn't need calc detection, either
#define OPTIMIZE_ROM_CALLS  // generates smaller code by reserving a5

//-----------------------------------------------------------------------------
// DIRTY: This is needed to get everything to work with "complex main"s
//        (Kevin Kofler)
//-----------------------------------------------------------------------------
asm("/* Include Patch: save_the_sp */");
extern void *__save__sp__;

#include <statline.h>
#include <alloc.h>
#include <vat.h>
#include <string.h>
#include <system.h>
#include <error.h>
#include <kbd.h>
#include <graph.h>
#include <menus.h>
#include <args.h>
#include "ttunpack.h"

#define fatal(s) {ST_showHelp(s); return;}


//-----------------------------------------------------------------------------
// we use an own implementation of enter_ghost_space, because due to the
// arrangements within TIGCCLIB (comes as real compile-time library since 2.4)
// otherwise we cannot generate a compatible pstarter.o anymore
// (the launcher generated with TIGCC option -pack will not be linked against
// tigcc.a)
//-----------------------------------------------------------------------------
void own_enter_ghost_space(void);
asm("own_enter_ghost_space:\n"
"	bsr.w 0f\n"
"0:\n"
"	move.l (%sp)+,%d0\n"
"	cmpi.l #0x40000,%d0\n"
"	bcc.s 2f\n"
"	movea.l 0xC8,%a0\n"
"	cmpi.l #1000,(%a0,-4)\n"
"	bcs.s 2f\n"
"	movem.l %a2-%a6/%d3-%d7,-(%sp)\n"
"	lea (%sp,-20),%sp\n"
"	move.l #0x3E000,%a3\n"
"	move.l %a0,%d0\n"
"	andi.l #0x600000,%d0\n"
"	addi.l #0x20000,%d0\n"
"	move.l %d0,(%sp,12)\n"
"	move.l %d0,(%sp,16)\n"
"	trap #0xC\n"
"	move.w #0x2700,%sr\n"
"	move.l #0xF,%d3\n"
"	pea 1f(%pc)\n"
"	bset.b #2,(%sp,1)\n"
"	clr.w  -(%sp)\n"
"	move.l 0xAC,%a0\n"
"	jmp (%a0)\n"
"1:\n"
"	lea (%sp,20),%sp\n"
"	movem.l (%sp)+,%a2-%a6/%d3-%d7\n"
"2:\n"
"	move.l (%sp)+,%d0\n"
"	bset.l #18,%d0\n"
"	movea.l %d0,%a0\n"
"	jmp (%a0)");


//-----------------------------------------------------------------------------
// The following macro calls function fptr and treats a possible RETURN_VALUE
// correctly. If a return value is available mode is set to 0, otherwise 1
//
// NOTE: the NOPs are very important due to a dirty hack in the TIGCCLIB with
//       define RETURN_VALUE (they must be exactly after the call!!)
//-----------------------------------------------------------------------------

#define ASM_CALL_WITH_RETURN_VALUE_HANDLING(fptr,mode) ({\
        asm volatile ("movem.l %%d1-%%d7/%%a0-%%a6,-(%%sp);"\
            "jsr (%1);"\
            "bra.s 0f;"\
            "nop;nop;"\
            "clr.b %%d0;"\
            "bra.s 1f;"\
            "0: st.b %%d0;"\
            "1: movem.l (%%sp)+,%%d1-%%d7/%%a0-%%a6;"\
            "move.b %%d0,%0"\
            : "=d" (mode) : "a" ((void *)(fptr)) : "d0","cc","memory");})


//-----------------------------------------------------------------------------
// embedded version string -- EDITED BY HAND!
//
// NOTE: this version string is embedded in ALL variants and its should !!NOT!!
//       be removed by anyone
//
// to force the compiler to embed the string in all case this variable is
// volatile by intention!
//-----------------------------------------------------------------------------
volatile const char embedded_ttstart_version[]="[tts117]";


//=============================================================================
// nothing special, just a huge main routine ...
//=============================================================================
void _main(void) {
  unsigned char*         src;
  unsigned char*         dest;
  unsigned short         length;
  char                   tmpstr[50];
  const char*            fname;
  SYM_ENTRY*             symptr;
  HANDLE                 h,uncomp_h=0;
  volatile unsigned char mode;


  //-------------------------------------------------------------------------
  // if you can figure out why the next lines are that strange, then you are
  // really good in C programming ...
  //-------------------------------------------------------------------------
  #define TOSTR(x) #x

//  fname = TOSTR(monodata);
  fname = TOSTR(monodata);

  //-------------------------------------------------------------------------
  // setup TIOS name for variable and try to find it in the current folder ..
  //-------------------------------------------------------------------------
  tmpstr[0] = 0;
  strcpy(tmpstr+1,fname);

  if(!(symptr = DerefSym(SymFind(tmpstr+1+strlen(fname))))) {
    // Prevent heap compression from crashing the calc; lock the folder
    FolderOp(SYMSTR ("\x7F"), FOP_LOCK);

    // Find the name of the first folder
    symptr = SymFindFirst(NULL, 0);

    // Keep looping until done
    while(symptr) {
      // Copy the name of the folder and the file name in path form
      sprintf(tmpstr + 1, "%s\\%s", symptr->name, fname);

      if((symptr = DerefSym(SymFind(tmpstr + 2 + strlen(fname) + strlen(symptr->name)))))
        goto contin;

      // Find the next folder. If done, stop
      symptr = SymFindNext();
    }
    // We're done, unlock the folder
    FolderOp(SYMSTR("\x7F"), FOP_UNLOCK);

    sprintf(tmpstr,"%s not found", fname);
    fatal(tmpstr);
  }

  contin:
  // We're done, unlock the folder
  FolderOp(SYMSTR("\x7F"), FOP_UNLOCK);

  //-------------------------------------------------------------------------
  // IMPORTANT: only use handle (symptr may become invalid !!!)
  //-------------------------------------------------------------------------
  h = symptr->handle;

  //-------------------------------------------------------------------------
  // if file is already locked, don't lock it again ...
  //-------------------------------------------------------------------------
  if (HeapGetLock(h)) {
      src = HeapDeref(h);
      h   = 0;
  } else
      src = HLock(h);

  if(!src) fatal("Lock failed"); // will return!

  length = *(unsigned short*)src+3;
  dest   = src+length-2;

  //---------------------------------------------------------------------
  // skip "length of variable" bytes
  //---------------------------------------------------------------------
  src += 2;
  if (*dest     != 0xF8 ||
      *(dest-4) != 'p'  ||
      *(dest-3) != 'p'  ||
      *(dest-2) != 'g'  ||
      !ttunpack_valid(src))
  {
    if(h) HeapUnlock(h);
    fatal("not PPG");
  }

  //---------------------------------------------------------------------
  // get the original size and allocate memory for it
  //---------------------------------------------------------------------
  length = ttunpack_size(src);

  // NOTE: we don't use malloc, but the low level routines
  //       otherwise compressed kernel-dependent progs will crash
  if (!(uncomp_h=HeapAllocHigh(length))) {
    if(h) HeapUnlock(h);
    fatal("out of mem");
  }

  dest = HeapDeref(uncomp_h);

  ST_showHelp("Please Wait...");
  if(ttunpack_decompress(src,dest)) {
    //-------------------------------------------------------------
    // "houston we got problems ..."
    //-------------------------------------------------------------
    HeapFree(uncomp_h);
    if(h) HeapUnlock(h);
    fatal("failed");
  }

  //-------------------------------------------------------------------------
  // relocate the executable, enter the ghostspace and start it ...
  //-------------------------------------------------------------------------
  // FIXED EX_patch call for upcoming AMS 2.06 (Thanx, Kevin for the fix)

  EX_patch(dest+0x40002,dest+length+0x3FFFF);

  own_enter_ghost_space();
  {(*(unsigned long *)__save__sp__)|=0x40000;}
  TRY
    ASM_CALL_WITH_RETURN_VALUE_HANDLING(dest+0x40002,mode);
  ONERR
    ERD_dialog(errCode,FALSE);
  ENDTRY

  HeapFree(uncomp_h);

  if(h) HeapUnlock(h);
}